unit uStatus;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Button1: TButton;
    Image1: TImage;
    Timer1: TTimer;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure StatusBar1DrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    nColor: smallInt;
    procedure ShowHint(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

// A barra de status  dividida em paneis, para facilitar o entendimento
// por terceiros, costumo usar constantes com o indice do painel
const
   PAN_HINT = 0;
   PAN_FAROL = 1;
   PAN_HORA = 2;
   PAN_ICON = 3;

const
   aCores: array [0..2] of TColor = (clGreen, clYellow, clRed);

procedure TForm1.FormCreate(Sender: TObject);
begin
   // Utilize o OnCreate do form principal para configurar Application.
   // Entre as configuraes mais comuns temos:
   // ** Designar a procedure de tratamento do evento OnHint
   Application.OnHint := ShowHint;

   // Inicializaes diversas
   nColor := 0;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   // Usando o evento OnResize, voce redimencionar ou
   // reposicionar componentes
   StatusBar1.Panels[PAN_HINT].Width := trunc(Width * 0.50);
   StatusBar1.Panels[PAN_FAROL].Width := trunc(Width * 0.20);
   StatusBar1.Panels[PAN_HORA].Width := trunc(Width * 0.20);
end;

procedure TForm1.ShowHint(Sender: TObject);
begin
   // Responsvel pela apresentao do Hint
   StatusBar1.Panels[PAN_HINT].Text := Application.Hint;
end;

procedure TForm1.StatusBar1DrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
   // Aqui determinamos qual  o painel que ser "desenhado"
   if Panel.Index = PAN_FAROL then
   with StatusBar1.Canvas do
   begin
      // Ajusta a cor e pinta o fundo
      Brush.Color := ACores[nColor];
      FillRect(Rect);
      // Ajusta a cor da fonte e apresenta um texto
      Font.Color := clBlack;
      TextOut(Rect.left + 4,  Rect.top + 2, TimeToStr(Now));
  end else
   if Panel.Index = PAN_ICON then
   with StatusBar1.Canvas do
   begin
      // Desenha o icone da aplicao
      StretchDraw(Rect, Image1.Picture.Icon);
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   // Muda a cor do farol
   inc(nColor);
   if nColor > high(aCores) then
      nColor := 0;
   StatusBar1.Refresh;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   // Apresenta a hora
   StatusBar1.Panels[PAN_HORA].Text := TimeToStr(Now);
end;

end.
